var SearchLoad_Options = {
	initialized: false,
	searchbar: null,
	textbox: null,
	enginesPopup: null,
	stringBundle: null,
	delayedClear: null,
	delayedReset: null,
	version: null,
	
	optionsDialog: function(){
		var winManager = Components.classes['@mozilla.org/appshell/window-mediator;1']
                        .getService(Components.interfaces.nsIWindowMediator);
		var recentWin = winManager.getMostRecentWindow("searchLoadOptions:Preferences");
		if( recentWin )
			recentWin.focus();
		else
			openDialog("chrome://searchload/content/preferences.xul", "", "dialog,centerscreen");
	},
	
	addMenuItem: function(){
		if(this.version===2)
		{
			if( this.enginesPopup && !document.getElementById("searchloadoptions-menuitem") )
			{
				var element = document.createElementNS(XUL_NS, "menuitem");
				element.setAttribute("class","open-engine-manager");
				element.setAttribute("id","searchloadoptions-menuitem");
				element.setAttribute("label",this.stringBundle.getString("searchoptions.label"));
				element.setAttribute("oncommand","SearchLoad_Options.optionsDialog();");
				this.enginesPopup.appendChild(element);
			}
		}
		else if(this.version===1)
		{
			if(SearchLoad_Options.textbox.onEnginePopupCommand.toString().indexOf("searchloadoptions-menuitem") === -1)
			eval("SearchLoad_Options.textbox.onEnginePopupCommand="+
				SearchLoad_Options.textbox.onEnginePopupCommand.toString().replace(
				"aEvent.target","aEvent.target;if(target.getAttribute(\"id\") == \"searchloadoptions-menuitem\"){return;}"
				)
			);
			if(SearchLoad_Options.textbox.onEnginePopupShowing.toString().indexOf("searchloadoptions-menuitem") === -1)
			eval("SearchLoad_Options.textbox.onEnginePopupShowing="+
				SearchLoad_Options.textbox.onEnginePopupShowing.toString().substring(0,
					SearchLoad_Options.textbox.onEnginePopupShowing.toString().lastIndexOf('}')).replace(
				"if (element)",
				"var searchloadoptions_menuitem = document.getElementById(\"searchloadoptions-menuitem\");"+
				"if (element || searchloadoptions_menuitem)"
				)+
				"element = document.createElementNS(XUL_NS, \"menuitem\");"+
				"element.setAttribute(\"id\",\"searchloadoptions-menuitem\");"+
				"element.setAttribute(\"label\",SearchLoad_Options.stringBundle.getString(\"searchoptions.label\"));"+
				"element.setAttribute(\"oncommand\",\"SearchLoad_Options.optionsDialog();\");"+
				"target.appendChild(element);}"
			);
			if(SearchLoad_Options.textbox.onEnginePopupHidden.toString().indexOf("searchloadoptions-menuitem") === -1)
			eval("SearchLoad_Options.textbox.onEnginePopupHidden="+
				SearchLoad_Options.textbox.onEnginePopupHidden.toString().replace(
				"\"addengine-menuitem\");",
				"\$&var searchloadoptions_menuitem = document.getElementById(\"searchloadoptions-menuitem\");"
				).replace(
				"if (element) {",
				"if (element && searchloadoptions_menuitem) {target.removeChild(target.lastChild);")
			);
		}
	},
	
	init: function(){
		this.searchbar = document.getElementById("searchbar");
		
		if(this.searchbar && "handleSearchCommand" in this.searchbar)
		{//Firefox 2.0
			this.version = 2;
			this.textbox = this.searchbar.textbox;
			this.enginesPopup = document.getAnonymousElementByAttribute(this.searchbar, "anonid", "searchbar-popup");
			
			if(this.searchbar.handleSearchCommand.toString().indexOf("searchLoadOptions_doSearch") === -1)
			{
				if(this.searchbar.handleSearchCommand.toString().indexOf("aOverride") === -1)
				{
					eval("this.searchbar.handleSearchCommand ="+this.searchbar.handleSearchCommand.toString()
						.substring(0,this.searchbar.handleSearchCommand.toString().lastIndexOf("^ newTabPref;")+13)
						.replace('aEvent.altKey','(aEvent.altKey||aEvent.ctrlKey)')
						+"}searchLoadOptions_doSearch(textValue, newTab);}"
					);
				}
				else
				{
					eval("this.searchbar.handleSearchCommand ="+this.searchbar.handleSearchCommand.toString()
						.substring(0,this.searchbar.handleSearchCommand.toString().lastIndexOf("^ newTabPref;")+13)
						.replace('aEvent.altKey','(aEvent.altKey||aEvent.ctrlKey)')
						+"}if(aOverride) this.doSearch(textValue, newTab, aOverride); else searchLoadOptions_doSearch(textValue, newTab);}"
					);
					eval("SecondSearch.initAllEngines ="+SecondSearch.initAllEngines.toString()
						.replace("source.childNodes[i].localName != \"menuitem\" ||","\$& source.childNodes[i].getAttribute('class').indexOf('searchbar-engine-menuitem') === -1 ||")
					);
				}
			}
		}
		else if(this.searchbar && "mTextbox" in this.searchbar)
		{//Firefox 1.5
			this.version = 1;
			this.textbox = this.searchbar.mTextbox;
			
			if(this.textbox.onTextEntered.toString().indexOf("searchLoadOptions_doSearch") === -1)
			eval("this.textbox.onTextEntered="+this.textbox.onTextEntered.toString()
				.replace('SearchLoadURL(searchURL, evt);','searchLoadOptions_doSearch(searchURL, (evt && evt.altKey));')
				.replace('SearchLoadURL','searchLoadOptions_doSearch')
				.replace('evt.altKey','(evt.altKey||evt.ctrlKey)')
			);
		}
		
		if(this.searchbar)
		{
			this.addMenuItem();
			this.initialized = true;
		}
	},//init
	
	uninit: function(){
		this.searchbar = null;
		this.textbox = null;
		this.enginesPopup = null;
		this.initialized = false;
	},
	
	startup: function(){
		if(BrowserCustomizeToolbar.toString().indexOf("function BrowserCustomizeToolbar()")===0)
		eval("BrowserCustomizeToolbar="+BrowserCustomizeToolbar.toString().replace(
			'var menubar','SearchLoad_Options.uninit();\$&'));
		
		if(BrowserToolboxCustomizeDone.toString().indexOf("function BrowserToolboxCustomizeDone(aToolboxChanged)")===0)
		eval("BrowserToolboxCustomizeDone="+BrowserToolboxCustomizeDone.toString().replace(
			'window.focus();','SearchLoad_Options.init();\$&'));
		
		var toolbox = document.getElementById("navigator-toolbox");
		toolbox.customizeDone = BrowserToolboxCustomizeDone;
		this.stringBundle = document.getElementById("searchloadoptions-stringbundle");
		this.init();
	}
};
window.addEventListener("load",function(loadEvent){SearchLoad_Options.startup();}, false);

function searchLoadOptions_doSearch(aURL, aInNewTab)
{
	if(SearchLoad_Options.version===2)
	{
		var postData = null;
		var submission = SearchLoad_Options.searchbar.currentEngine.getSubmission(aURL, null);
		if (submission) {
			var url = submission.uri.spec;
			postData = submission.postData;
		}
	}
	else if(SearchLoad_Options.version===1 && !aURL) return;
	
	var clearSearchBarPref = gPrefService.getBoolPref("extensions.searchload.clearonsearch");
	var clearDelayPref     = gPrefService.getIntPref("extensions.searchload.cleardelay");
	var resetSearchBarPref = gPrefService.getBoolPref("extensions.searchload.resetonsearch");
	var resetDelayPref     = gPrefService.getIntPref("extensions.searchload.resetdelay");
	var cancelClearPref    = gPrefService.getBoolPref("extensions.searchload.cancelclear");
	var cancelResetPref    = gPrefService.getBoolPref("extensions.searchload.cancelreset");
	var defaultEnginePref  = gPrefService.getCharPref("extensions.searchload.defaultengine");
	var tabControlPref     = gPrefService.getIntPref("extensions.searchload.newtab");
	var detectBlankPref    = gPrefService.getBoolPref("extensions.searchload.detectblanktab");
	var detectHomePref     = gPrefService.getBoolPref("extensions.searchload.detecthometab");
	
	
	//clear searchbar
	if(SearchLoad_Options.searchbar && clearSearchBarPref)
	{
		if(clearDelayPref==0)
		{
			if(SearchLoad_Options.version===2)
				SearchLoad_Options.searchbar.value = '';
			else if(SearchLoad_Options.version===1)
				SearchLoad_Options.textbox.value = '';
		}
		else if(clearDelayPref>0)
		{
			window.clearTimeout(SearchLoad_Options.delayedClear);
			SearchLoad_Options.delayedClear = window.setTimeout(
				function(){
					if( !cancelClearPref || !SearchLoad_Options.textbox.hasAttribute("focused") )
					{
						if(SearchLoad_Options.version===2)
							SearchLoad_Options.searchbar.value = '';
						else if(SearchLoad_Options.version===1)
							SearchLoad_Options.textbox.value = '';
						var changeEvent = document.createEvent('Event');
						changeEvent.initEvent('change', true, true);
						setTimeout(function(){SearchLoad_Options.textbox.dispatchEvent(changeEvent);},0);
					}
					SearchLoad_Options.delayedClear = null;
				},clearDelayPref*1000);
		}
	}//done clearing
	
	
	//reset searchbar
	if(SearchLoad_Options.searchbar && resetSearchBarPref)
	{
		if(SearchLoad_Options.version === 2)
			var selectedEngine = SearchLoad_Options.searchbar.currentEngine.name;
		else if(SearchLoad_Options.version === 1)
			var selectedEngine = gPrefService.getCharPref("browser.search.selectedEngine");
		
		if(selectedEngine != defaultEnginePref)
		{
				if(resetDelayPref==0)
				{
					if(SearchLoad_Options.version === 2)
					{
						if( SearchLoad_Options.searchbar.searchService.getEngineByName(defaultEnginePref) )
							SearchLoad_Options.searchbar.currentEngine = SearchLoad_Options.searchbar.searchService.getEngineByName(defaultEnginePref);
					}
					else if(SearchLoad_Options.version === 1)
					{
						SearchLoad_Options.textbox.setEngineByName(defaultEnginePref);
						if(!SearchLoad_Options.textbox.currentEngine)
							SearchLoad_Options.textbox.currentEngine = SearchLoad_Options.textbox.getDefaultEngine();
					}
				}
				else if(resetDelayPref>0)
				{
					window.clearTimeout(SearchLoad_Options.delayedReset);
					SearchLoad_Options.delayedReset = window.setTimeout(
						function(){
						if( !cancelResetPref || !SearchLoad_Options.textbox.hasAttribute("focused") )
						{
							if(SearchLoad_Options.version === 2)
							{
								if( SearchLoad_Options.searchbar.searchService.getEngineByName(defaultEnginePref) )
									SearchLoad_Options.searchbar.currentEngine = SearchLoad_Options.searchbar.searchService.getEngineByName(defaultEnginePref);
							}
							else if(SearchLoad_Options.version === 1)
							{
								SearchLoad_Options.textbox.setEngineByName(defaultEnginePref);
								if(!SearchLoad_Options.textbox.currentEngine)
									SearchLoad_Options.textbox.currentEngine = SearchLoad_Options.textbox.getDefaultEngine();
							}
						}
						SearchLoad_Options.delayedReset = null;
						},resetDelayPref*1000);
				}
		}
	}//done resetting
	
	
	
	if(SearchLoad_Options.version === 2)
	{
		//load url and postData
		var _loadActiveTab = "loadURI(url, null, postData, false);";
		var _loadNewTab = "getBrowser().loadOneTab(url, null, null, postData, false, false);";
		var _loadBgTab = "getBrowser().loadOneTab(url, null, null, postData, true, false);";
	}
	else if(SearchLoad_Options.version === 1)
	{
		//load aURL
		var _loadActiveTab = "loadURI(aURL,null,null);";
		var _loadNewTab = "gBrowser.selectedTab = gBrowser.addTab(aURL, null);";
		var _loadBgTab = "gBrowser.addTab(aURL,null);";
	}
	//load search
	if(aInNewTab)
	{
		content.focus();
		eval(_loadNewTab);
		content.focus();
	}
	else
	{
		var currentURL = getWebNavigation().currentURI.spec;
		var homeTabDetected = false;
		if(detectHomePref)
		{
			var truncateURL = function(aURLString)
			{
				aURLString = aURLString.replace(/^\s+/,"").replace(/\s+$/,"");
				if(aURLString.indexOf("https://")===0)
					return aURLString.replace(/^https:\/\//,"").replace(/^www./,"").replace(/\/$/,"");
				else
					return aURLString.replace(/^http:\/\//,"").replace(/^www./,"").replace(/\/$/,"");
			};
			var homepages = gPrefService.getCharPref("browser.startup.homepage");
			    homepages = homepages.split("|");
			currentURL = truncateURL(currentURL);
			for(var i=0; i<homepages.length; i++)
			if( currentURL==truncateURL(homepages[i]) )
			{
				homeTabDetected = true;
				break;
			}
		}
		
		if(tabControlPref==0 || (detectBlankPref && currentURL=="about:blank" || detectHomePref && homeTabDetected)&&
			!getWebNavigation().nsIWebProgress.isLoadingDocument)
		{
			eval(_loadActiveTab);
			content.focus();
		}
		else switch(tabControlPref)
		{
			case 1:
				content.focus();
				eval(_loadNewTab);
				content.focus();
				break;
			case 2:
				eval(_loadBgTab);
		}
	}//done loading
}//searchLoadOptions_doSearch